#ifndef C_BATTLE_H
#define C_BATTLE_H

#include "c_options.h"
#include <windows.h>

#define APP_NAME TEXT("c_battle")
#define APP_VERSION TEXT("0.1a")
#define PRODUCT_NAME APP_NAME TEXT(" ") APP_VERSION

#define NELEMS(arr) (sizeof (arr) / sizeof *(arr))

#ifdef NDEBUG
#define ASSERT(expr)
#else
#define ASSERT(expr) \
	do { \
		extern char err_msg_buf[]; \
		if (!(expr)) { \
			DWORD gle = GetLastError(); \
			wsprintfA(err_msg_buf, \
				"Sorry, the following assertion failed in " \
				__FILE__ ", line %d, last error code: %lu\n\n" \
				"\t" #expr "\n\n" \
				"Please report this to horny@mail.az\n" \
				"Will now quit. Have phun.\n\n" \
				"Built on " __DATE__ " " __TIME__, \
				__LINE__, gle); \
			MessageBoxA(NULL, err_msg_buf, PRODUCT_NAME, MB_SYSTEMMODAL); \
			ExitProcess(gle); \
		} \
	} while (0)
#endif /* defined(NDEBUG) */

#define ME 0
#define ENEMY 1

#define NUM_SHIPS 4
#define NUM_CELLS 10

#define MAX_PLAYER_NAME 16

#define CELL_EQUAL(c1, c2) (((c1).x == (c2).x) && ((c1).y == (c2).y))

#define LKG_SET(pdata, cell) (void) ((pdata).lkg = cell)
#define LKG_CLEAR(pdata) (void) ((pdata).lkg.x = -1, (pdata).lkg.y = -1)
#define LKG_EXISTS(pdata) ((pdata).lkg.x != -1 && (pdata).lkg.y != -1)

#define IDM_MAIN			101
#define IDM_RANDOMIZE		102

#define IDM_AI_LEVEL_1		103
#define IDM_AI_LEVEL_2		104
#define IDM_AI_LEVEL_3		105

#define IDM_COLOR_BG		107
#define IDM_COLOR_GRID		108
#define IDM_COLOR_HIGHLIGHT	109
#define IDM_COLOR_SHIP		110
#define IDM_COLOR_MISS		111
#define IDM_COLOR_HIT		112

#define IDM_ABOUT			113

#define IDD_MAIN			201



typedef enum { ctFree, ctShip, ctHit, ctMiss } cell_t;

typedef cell_t (*map_t)[NUM_CELLS];

typedef enum { dirHorz, dirVert, NUM_DIRS } dir_t;

typedef enum { actVoid, actMiss, actHit, actSink } action_t;

typedef struct {
	POINT cur_cell;
	POINT lkg;
	cell_t map[NUM_CELLS][NUM_CELLS];
	char name[MAX_PLAYER_NAME + 1];
} player_data_t;

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void highlight_cell(POINT, int, HDC, BOOL, const game_options_t *);
void reset_player_data(player_data_t *);
action_t action(player_data_t [2], int, HWND, int);
POINT get_enemy_move(player_data_t *, HWND, int);

#endif /* !defined(C_BATTLE_H) */
