#include "c_battle.h"
#include "c_options.h"
#include <windows.h>
#include <stdlib.h>

static TCHAR ini_file[MAX_PATH];

static struct {
	TCHAR string[16];
	COLORREF rgb;
} default_colors[NUM_COLORS] = {
	TEXT("clrBg"), RGB(100, 150, 255),
	TEXT("clrGrid"), RGB(0, 0, 100),
	TEXT("clrHighlight"), RGB(255, 255, 255),
	TEXT("clrShip"), RGB(0, 0, 0),
	TEXT("clrMiss"), RGB(0, 0, 0),
	TEXT("clrHit"), RGB(255, 0, 0)
};

void read_options(game_options_t *options, HMENU hmenu) {
	int i;

	lstrcpy(ini_file, TEXT(".\\") APP_NAME TEXT(".ini"));

	options->ai_level = GetPrivateProfileInt(TEXT("common"), TEXT("ai_level"),
			DEFAULT_AI_LEVEL, ini_file);

	for (i = 0; i < NUM_COLORS; i++)
		options->color[i] = GetPrivateProfileInt(TEXT("colors"), default_colors[i].string,
				default_colors[i].rgb, ini_file);

	CheckMenuRadioItem(GetSubMenu(hmenu, 1), IDM_AI_LEVEL_1, IDM_AI_LEVEL_3,
			IDM_AI_LEVEL_1 + options->ai_level - 1, MF_BYCOMMAND);
}

void save_options(const game_options_t *options, HMENU hmenu) {
	int i;
	TCHAR value[16];

	ASSERT(*ini_file != '\0');
	wsprintf(value, "%d", options->ai_level);
	WritePrivateProfileString(TEXT("common"), TEXT("ai_level"), value, ini_file);
	for (i = 0; i < NUM_COLORS; i++) {
		wsprintf(value, "%lu", options->color[i]);
		WritePrivateProfileString(TEXT("colors"), default_colors[i].string, value, ini_file);
	}

	UNREFERENCED_PARAMETER(hmenu);
}
